/*!
FullCalendar Scheduler v5.7.0
Docs & License: https://fullcalendar.io/scheduler
(c) 2021 Adam Shaw
*/
var FullCalendarTimeline=function(e,t,n,i){"use strict";function r(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var o=r(n),a=function(e,t){return(a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)};function s(e,t){function n(){this.constructor=e}a(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var l=function(){return(l=Object.assign||function(e){for(var t,n=1,i=arguments.length;n<i;n++)for(var r in t=arguments[n])Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r]);return e}).apply(this,arguments)};t.config.MAX_TIMELINE_SLOTS=1e3;var c=[{years:1},{months:1},{days:1},{hours:1},{minutes:30},{minutes:15},{minutes:10},{minutes:5},{minutes:1},{seconds:30},{seconds:15},{seconds:10},{seconds:5},{seconds:1},{milliseconds:500},{milliseconds:100},{milliseconds:10},{milliseconds:1}];function u(e,n,i,r){var o={labelInterval:i.slotLabelInterval,slotDuration:i.slotDuration};!function(e,n,i){var r=n.currentRange;if(e.labelInterval){i.countDurationsBetween(r.start,r.end,e.labelInterval)>t.config.MAX_TIMELINE_SLOTS&&(console.warn("slotLabelInterval results in too many cells"),e.labelInterval=null)}if(e.slotDuration){i.countDurationsBetween(r.start,r.end,e.slotDuration)>t.config.MAX_TIMELINE_SLOTS&&(console.warn("slotDuration results in too many cells"),e.slotDuration=null)}if(e.labelInterval&&e.slotDuration){var o=t.wholeDivideDurations(e.labelInterval,e.slotDuration);(null===o||o<1)&&(console.warn("slotLabelInterval must be a multiple of slotDuration"),e.slotDuration=null)}}(o,e,n),h(o,e,n),function(e,n,i){var r=n.currentRange,o=e.slotDuration;if(!o){for(var a=h(e,n,i),s=0,l=c;s<l.length;s++){var u=l[s],d=t.createDuration(u),f=t.wholeDivideDurations(a,d);if(null!==f&&f>1&&f<=6){o=d;break}}if(o)i.countDurationsBetween(r.start,r.end,o)>200&&(o=null);o||(o=a),e.slotDuration=o}}(o,e,n);var a=i.slotLabelFormat,s=Array.isArray(a)?a:null!=a?[a]:function(e,n,i,r){var o,a,s=e.labelInterval,l=t.greatestDurationDenominator(s).unit,c=r.weekNumbers,u=o=a=null;"week"!==l||c||(l="day");switch(l){case"year":u={year:"numeric"};break;case"month":m("years",n,i)>1&&(u={year:"numeric"}),o={month:"short"};break;case"week":m("years",n,i)>1&&(u={year:"numeric"}),o={week:"narrow"};break;case"day":m("years",n,i)>1?u={year:"numeric",month:"long"}:m("months",n,i)>1&&(u={month:"long"}),c&&(o={week:"short"}),a={weekday:"narrow",day:"numeric"};break;case"hour":c&&(u={week:"short"}),m("days",n,i)>1&&(o={weekday:"short",day:"numeric",month:"numeric",omitCommas:!0}),a={hour:"numeric",minute:"2-digit",omitZeroMinute:!0,meridiem:"short"};break;case"minute":t.asRoughMinutes(s)/60>=6?(u={hour:"numeric",meridiem:"short"},o=function(e){return":"+t.padStart(e.date.minute,2)}):u={hour:"numeric",minute:"numeric",meridiem:"short"};break;case"second":t.asRoughSeconds(s)/60>=6?(u={hour:"numeric",minute:"2-digit",meridiem:"lowercase"},o=function(e){return":"+t.padStart(e.date.second,2)}):u={hour:"numeric",minute:"2-digit",second:"2-digit",meridiem:"lowercase"};break;case"millisecond":u={hour:"numeric",minute:"2-digit",second:"2-digit",meridiem:"lowercase"},o=function(e){return"."+t.padStart(e.millisecond,3)}}return[].concat(u||[],o||[],a||[])}(o,e,n,i);o.headerFormats=s.map((function(e){return t.createFormatter(e)})),o.isTimeScale=Boolean(o.slotDuration.milliseconds);var l=null;if(!o.isTimeScale){var u=t.greatestDurationDenominator(o.slotDuration).unit;/year|month|week/.test(u)&&(l=u)}o.largeUnit=l,o.emphasizeWeeks=1===t.asCleanDays(o.slotDuration)&&m("weeks",e,n)>=2&&!i.businessHours;var g,v,y=i.snapDuration;y&&(g=t.createDuration(y),v=t.wholeDivideDurations(o.slotDuration,g)),null==v&&(g=o.slotDuration,v=1),o.snapDuration=g,o.snapsPerSlot=v;var D=t.asRoughMs(e.slotMaxTime)-t.asRoughMs(e.slotMinTime),S=d(e.renderRange.start,o,n),R=d(e.renderRange.end,o,n);o.isTimeScale&&(S=n.add(S,e.slotMinTime),R=n.add(t.addDays(R,-1),e.slotMaxTime)),o.timeWindowMs=D,o.normalizedRange={start:S,end:R};for(var C=[],E=S;E<R;)f(E,o,e,r)&&C.push(E),E=n.add(E,o.slotDuration);o.slotDates=C;var b=-1,w=0,k=[],P=[];for(E=S;E<R;)f(E,o,e,r)?(b+=1,k.push(b),P.push(w)):k.push(b+.5),E=n.add(E,o.snapDuration),w+=1;return o.snapDiffToIndex=k,o.snapIndexToDiff=P,o.snapCnt=b+1,o.slotCnt=o.snapCnt/o.snapsPerSlot,o.isWeekStarts=function(e,t){for(var n=e.slotDates,i=e.emphasizeWeeks,r=null,o=[],a=0,s=n;a<s.length;a++){var l=s[a],c=t.computeWeekNumber(l),u=i&&null!==r&&r!==c;r=c,o.push(u)}return o}(o,n),o.cellRows=function(e,n){for(var i=e.slotDates,r=e.headerFormats,o=r.map((function(){return[]})),a=t.asCleanDays(e.slotDuration),s=7===a?"week":1===a?"day":null,l=r.map((function(e){return e.getLargestUnit?e.getLargestUnit():null})),c=0;c<i.length;c+=1)for(var u=i[c],d=e.isWeekStarts[c],f=0;f<r.length;f+=1){var h=r[f],m=o[f],g=m[m.length-1],v=f===r.length-1,y=r.length>1&&!v,D=null,S=l[f]||(v?s:null);if(y){var R=n.format(u,h);g&&g.text===R?g.colspan+=1:D=p(u,R,S)}else if(!g||t.isInt(n.countDurationsBetween(e.normalizedRange.start,u,e.labelInterval))){R=n.format(u,h);D=p(u,R,S)}else g.colspan+=1;D&&(D.weekStart=d,m.push(D))}return o}(o,n),o.slotsPerLabel=t.wholeDivideDurations(o.labelInterval,o.slotDuration),o}function d(e,n,i){var r=e;return n.isTimeScale||(r=t.startOfDay(r),n.largeUnit&&(r=i.startOf(r,n.largeUnit))),r}function f(e,n,i,r){if(r.isHiddenDay(e))return!1;if(n.isTimeScale){var o=t.startOfDay(e),a=e.valueOf()-o.valueOf()-t.asRoughMs(i.slotMinTime);return(a=(a%864e5+864e5)%864e5)<n.timeWindowMs}return!0}function h(e,n,i){var r=n.currentRange,o=e.labelInterval;if(!o){var a=void 0;if(e.slotDuration){for(var s=0,l=c;s<l.length;s++){a=l[s];var u=t.createDuration(a),d=t.wholeDivideDurations(u,e.slotDuration);if(null!==d&&d<=6){o=u;break}}o||(o=e.slotDuration)}else for(var f=0,h=c;f<h.length;f++){if(a=h[f],o=t.createDuration(a),i.countDurationsBetween(r.start,r.end,o)>=18)break}e.labelInterval=o}return o}function m(e,n,i){var r=n.currentRange,o=null;return"years"===e?o=i.diffWholeYears(r.start,r.end):"months"===e||"weeks"===e?o=i.diffWholeMonths(r.start,r.end):"days"===e&&(o=t.diffWholeDays(r.start,r.end)),o||0}function p(e,t,n){return{date:e,text:t,rowUnit:n,colspan:1,isWeekStart:!1}}var g=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context,i=e.navLinkData?{"data-navlink":e.navLinkData,tabIndex:0}:{};return t.createElement(t.ContentHook,{hookProps:e.hookProps,content:n.options.slotLabelContent,defaultContent:v},(function(n,r){return t.createElement("a",l({ref:n,className:"fc-timeline-slot-cushion fc-scrollgrid-sync-inner"+(e.isSticky?" fc-sticky":"")},i),r)}))},n}(t.BaseComponent);function v(e){return e.text}function y(e){return{level:e.level,date:e.dateEnv.toDate(e.dateMarker),view:e.viewApi,text:e.text}}var D=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.refineHookProps=t.memoizeObjArg(y),n.normalizeClassNames=t.buildClassNameNormalizer(),n}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context,i=n.dateEnv,r=n.options,o=e.cell,a=e.dateProfile,s=e.tDateProfile,l=t.getDateMeta(o.date,e.todayRange,e.nowDate,a),c=["fc-timeline-slot","fc-timeline-slot-label"].concat("time"===o.rowUnit?t.getSlotClassNames(l,n.theme):t.getDayClassNames(l,n.theme));o.isWeekStart&&c.push("fc-timeline-slot-em");var u=r.navLinks&&o.rowUnit&&"time"!==o.rowUnit?t.buildNavLinkData(o.date,o.rowUnit):null,d=this.refineHookProps({level:e.rowLevel,dateMarker:o.date,text:o.text,dateEnv:n.dateEnv,viewApi:n.viewApi}),f=this.normalizeClassNames(r.slotLabelClassNames,d);return t.createElement(t.MountHook,{hookProps:d,didMount:r.slotLabelDidMount,willUnmount:r.slotLabelWillUnmount},(function(n){return t.createElement("th",{ref:n,className:c.concat(f).join(" "),"data-date":i.formatIso(o.date,{omitTime:!s.isTimeScale,omitTimeZoneOffset:!0}),colSpan:o.colspan},t.createElement("div",{className:"fc-timeline-slot-frame",style:{height:e.rowInnerHeight}},t.createElement(g,{hookProps:d,isSticky:e.isSticky,navLinkData:u})))}))},n}(t.BaseComponent),S=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=e.dateProfile,i=e.tDateProfile,r=e.rowInnerHeights,o=e.todayRange,a=e.nowDate,s=i.cellRows;return t.createElement(t.Fragment,null,s.map((function(e,l){var c=l===s.length-1,u=["fc-timeline-header-row",i.isTimeScale&&c?"fc-timeline-header-row-chrono":""];return t.createElement("tr",{key:l,className:u.join(" ")},e.map((function(e){return t.createElement(D,{key:e.date.toISOString(),cell:e,rowLevel:l,dateProfile:n,tDateProfile:i,todayRange:o,nowDate:a,rowInnerHeight:r&&r[l],isSticky:!c})})))})))},n}(t.BaseComponent),R=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n}return s(n,e),n.prototype.render=function(){var e=this,n=this.props,i=this.context,r=t.greatestDurationDenominator(n.tDateProfile.slotDuration).unit,o=n.slatCoords&&n.slatCoords.dateProfile===n.dateProfile?n.slatCoords:null;return t.createElement(t.NowTimer,{unit:r},(function(r,a){return t.createElement("div",{className:"fc-timeline-header",ref:e.rootElRef},t.createElement("table",{className:"fc-scrollgrid-sync-table",style:{minWidth:n.tableMinWidth,width:n.clientWidth}},n.tableColGroupNode,t.createElement("tbody",null,t.createElement(S,{dateProfile:n.dateProfile,tDateProfile:n.tDateProfile,nowDate:r,todayRange:a,rowInnerHeights:n.rowInnerHeights}))),i.options.nowIndicator&&t.createElement("div",{className:"fc-timeline-now-indicator-container"},o&&o.isDateInRange(r)&&t.createElement(t.NowIndicatorRoot,{isAxis:!0,date:r},(function(e,n,i,a){return t.createElement("div",{ref:e,className:["fc-timeline-now-indicator-arrow"].concat(n).join(" "),style:{left:o.dateToCoord(r)}},a)}))))}))},n.prototype.componentDidMount=function(){this.updateSize()},n.prototype.componentDidUpdate=function(){this.updateSize()},n.prototype.updateSize=function(){this.props.onMaxCushionWidth&&this.props.onMaxCushionWidth(this.computeMaxCushionWidth())},n.prototype.computeMaxCushionWidth=function(){return Math.max.apply(Math,t.findElements(this.rootElRef.current,".fc-timeline-header-row:last-child .fc-timeline-slot-cushion").map((function(e){return e.getBoundingClientRect().width})))},n}(t.BaseComponent),C=function(){function e(e,n,i,r,o,a){this.slatRootEl=e,this.dateProfile=i,this.tDateProfile=r,this.dateEnv=o,this.isRtl=a,this.outerCoordCache=new t.PositionCache(e,n,!0,!1),this.innerCoordCache=new t.PositionCache(e,t.findDirectChildren(n,"div"),!0,!1)}return e.prototype.rangeToCoords=function(e){return this.isRtl?{right:this.dateToCoord(e.start),left:this.dateToCoord(e.end)}:{left:this.dateToCoord(e.start),right:this.dateToCoord(e.end)}},e.prototype.isDateInRange=function(e){return t.rangeContainsMarker(this.dateProfile.currentRange,e)},e.prototype.dateToCoord=function(e){var t=this.tDateProfile,n=this.computeDateSnapCoverage(e)/t.snapsPerSlot,i=Math.floor(n),r=n-(i=Math.min(i,t.slotCnt-1)),o=this.innerCoordCache,a=this.outerCoordCache;return this.isRtl?a.rights[i]-o.getWidth(i)*r-a.originClientRect.width:a.lefts[i]+o.getWidth(i)*r},e.prototype.computeDateSnapCoverage=function(e){return E(e,this.tDateProfile,this.dateEnv)},e.prototype.computeDurationLeft=function(e){var n=this.dateProfile,i=this.tDateProfile,r=this.dateEnv,o=this.isRtl,a=0;if(n){var s=r.add(n.activeRange.start,e);i.isTimeScale||(s=t.startOfDay(s)),a=this.dateToCoord(s),!o&&a&&(a+=1)}return a},e}();function E(e,n,i){var r=i.countDurationsBetween(n.normalizedRange.start,e,n.snapDuration);if(r<0)return 0;if(r>=n.snapDiffToIndex.length)return n.snapCnt;var o=Math.floor(r),a=n.snapDiffToIndex[o];return t.isInt(a)?a+=r-o:a=Math.ceil(a),a}var b=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context,i=n.dateEnv,r=n.options,o=n.theme,a=e.date,s=e.tDateProfile,c=e.isEm,u=t.getDateMeta(e.date,e.todayRange,e.nowDate,e.dateProfile),d=["fc-timeline-slot","fc-timeline-slot-lane"],f={"data-date":i.formatIso(a,{omitTimeZoneOffset:!0,omitTime:!s.isTimeScale})},h=l(l({date:i.toDate(e.date)},u),{view:n.viewApi});return c&&d.push("fc-timeline-slot-em"),s.isTimeScale&&d.push(t.isInt(i.countDurationsBetween(s.normalizedRange.start,e.date,s.labelInterval))?"fc-timeline-slot-major":"fc-timeline-slot-minor"),d.push.apply(d,e.isDay?t.getDayClassNames(u,o):t.getSlotClassNames(u,o)),t.createElement(t.RenderHook,{hookProps:h,classNames:r.slotLaneClassNames,content:r.slotLaneContent,didMount:r.slotLaneDidMount,willUnmount:r.slotLaneWillUnmount,elRef:e.elRef},(function(e,n,i,r){return t.createElement("td",l({ref:e,className:d.concat(n).join(" ")},f),t.createElement("div",{ref:i},r))}))},n}(t.BaseComponent),w=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=e.tDateProfile,i=e.cellElRefs,r=n.slotDates,o=n.isWeekStarts,a=!n.isTimeScale&&!n.largeUnit;return t.createElement("tbody",null,t.createElement("tr",null,r.map((function(r,s){var l=r.toISOString();return t.createElement(b,{key:l,elRef:i.createRef(l),date:r,dateProfile:e.dateProfile,tDateProfile:n,nowDate:e.nowDate,todayRange:e.todayRange,isEm:o[s],isDay:a})}))))},n}(t.BaseComponent),k=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n.cellElRefs=new t.RefMap,n.handleScrollRequest=function(e){var t=n.props.onScrollLeftRequest,i=n.coords;if(t&&i){if(e.time)t(i.computeDurationLeft(e.time));return!0}return null},n}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context;return t.createElement("div",{className:"fc-timeline-slots",ref:this.rootElRef},t.createElement("table",{className:n.theme.getClass("table"),style:{minWidth:e.tableMinWidth,width:e.clientWidth}},e.tableColGroupNode,t.createElement(w,{cellElRefs:this.cellElRefs,dateProfile:e.dateProfile,tDateProfile:e.tDateProfile,nowDate:e.nowDate,todayRange:e.todayRange})))},n.prototype.componentDidMount=function(){this.updateSizing(),this.scrollResponder=this.context.createScrollResponder(this.handleScrollRequest)},n.prototype.componentDidUpdate=function(e){this.updateSizing(),this.scrollResponder.update(e.dateProfile!==this.props.dateProfile)},n.prototype.componentWillUnmount=function(){this.scrollResponder.detach(),this.props.onCoords&&this.props.onCoords(null)},n.prototype.updateSizing=function(){var e,t=this.props,n=this.context;null!==t.clientWidth&&this.scrollResponder&&(this.rootElRef.current.offsetWidth&&(this.coords=new C(this.rootElRef.current,(e=this.cellElRefs.currentMap,t.tDateProfile.slotDates.map((function(t){var n=t.toISOString();return e[n]}))),t.dateProfile,t.tDateProfile,n.dateEnv,n.isRtl),t.onCoords&&t.onCoords(this.coords),this.scrollResponder.update(!1)))},n.prototype.positionToHit=function(e){var n=this.coords.outerCoordCache,i=this.context,r=i.dateEnv,o=i.isRtl,a=this.props.tDateProfile,s=n.leftToIndex(e);if(null!=s){var l=n.getWidth(s),c=o?(n.rights[s]-e)/l:(e-n.lefts[s])/l,u=Math.floor(c*a.snapsPerSlot),d=r.add(a.slotDates[s],t.multiplyDuration(a.snapDuration,u));return{dateSpan:{range:{start:d,end:r.add(d,a.snapDuration)},allDay:!this.props.tDateProfile.isTimeScale},dayEl:this.cellElRefs.currentMap[s],left:n.lefts[s],right:n.rights[s]}}return null},n}(t.BaseComponent);var P=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=[].concat(e.eventResizeSegs,e.dateSelectionSegs);return e.timelineCoords&&t.createElement("div",{className:"fc-timeline-bg"},this.renderSegs(e.businessHourSegs||[],e.timelineCoords,"non-business"),this.renderSegs(e.bgEventSegs||[],e.timelineCoords,"bg-event"),this.renderSegs(n,e.timelineCoords,"highlight"))},n.prototype.renderSegs=function(e,n,i){var r=this.props,o=r.todayRange,a=r.nowDate,s=e.map((function(e){var r=n.rangeToCoords(e);return t.createElement("div",{key:t.buildEventRangeKey(e.eventRange),className:"fc-timeline-bg-harness",style:{left:r.left,right:-r.right}},"bg-event"===i?t.createElement(t.BgEvent,l({seg:e},t.getSegMeta(e,o,a))):t.renderFill(i))}));return t.createElement(t.Fragment,null,s)},n}(t.BaseComponent),M=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.sliceRange=function(e,n,i,r,o){var a=function(e,n,i){if(!n.isTimeScale&&(e=t.computeVisibleDayRange(e),n.largeUnit)){var r=e;((e={start:i.startOf(e.start,n.largeUnit),end:i.startOf(e.end,n.largeUnit)}).end.valueOf()!==r.end.valueOf()||e.end<=e.start)&&(e={start:e.start,end:i.add(e.end,n.slotDuration)})}return e}(e,r,o),s=[];if(E(a.start,r,o)<E(a.end,r,o)){var l=t.intersectRanges(a,r.normalizedRange);l&&s.push({start:l.start,end:l.end,isStart:l.start.valueOf()===a.start.valueOf()&&f(l.start,r,n,i),isEnd:l.end.valueOf()===a.end.valueOf()&&f(t.addMs(l.end,-1),r,n,i)})}return s},n}(t.Slicer),T=t.createFormatter({hour:"numeric",minute:"2-digit",omitZeroMinute:!0,meridiem:"narrow"}),I=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props;return t.createElement(t.StandardEvent,l({},e,{extraClassNames:["fc-timeline-event","fc-h-event"],defaultTimeFormat:T,defaultDisplayEventTime:!e.isTimeScale}))},n}(t.BaseComponent),W=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n}return s(n,e),n.prototype.render=function(){var e=this,n=this.props,i=n.hiddenSegs,r=n.elRef,o=n.placement,a=n.resourceId,s=a?{resourceId:a}:{};return t.createElement(t.MoreLinkRoot,{allDayDate:null,moreCnt:i.length,allSegs:i,hiddenSegs:i,alignmentElRef:this.rootElRef,dateProfile:n.dateProfile,todayRange:n.todayRange,extraDateSpan:s,popoverContent:function(){return t.createElement(t.Fragment,null,i.map((function(e){var i=e.eventRange.instance.instanceId;return t.createElement("div",{key:i,style:{visibility:n.isForcedInvisible[i]?"hidden":""}},t.createElement(I,l({isTimeScale:n.isTimeScale,seg:e,isDragging:!1,isResizing:!1,isDateSelecting:!1,isSelected:i===n.eventSelection},t.getSegMeta(e,n.todayRange,n.nowDate))))})))}},(function(n,i,a,s,l){return t.createElement("a",{ref:function(i){t.setRef(n,i),t.setRef(r,i),t.setRef(e.rootElRef,i)},className:["fc-timeline-more-link"].concat(i).join(" "),style:{left:o.left,right:-o.right,top:o.top,visibility:o.isVisible?"":"hidden"},onClick:l},t.createElement("div",{ref:a,className:"fc-timeline-more-link-inner fc-sticky"},s))}))},n}(t.BaseComponent);function x(e,n,i,r,o,a,s,l){var c=[],u=[];if(n)for(var d=0;d<e.length;d+=1){var f=e[d],h=i[f.eventRange.instance.instanceId],m=n.rangeToCoords(f),p=Math.round(m.left),g=Math.round(m.right);g-p<o&&(a?p=g-o:g=p+o),null!=h?c.push({index:d,spanStart:p,spanEnd:g,thickness:h}):u.push({seg:f,isVisible:!1,left:p,right:g,top:0})}var v=new t.SegHierarchy;null!=s&&(v.strictOrder=s),null!=l&&(v.maxStackCnt=l);var y=v.addSegs(c),D=y.map((function(t){return{seg:e[t.segInput.index],isVisible:!1,left:t.spanStart,right:t.spanEnd,top:0}})),S=t.groupIntersectingEntries(y),R=[],C=[],E=function(t){return e[t.segInput.index]};for(d=0;d<S.length;d+=1){var b=S[d],w=b.entries.map(E);null!=(h=r[t.buildIsoString(t.computeEarliestSegStart(w))])?R.push({index:e.length+d,spanStart:b.spanStart,spanEnd:b.spanEnd,thickness:h}):C.push({seg:w,isVisible:!1,left:b.spanStart,right:b.spanEnd,top:0})}v.maxStackCnt=-1,v.addSegs(R);for(var k=[],P=0,M=0,T=v.toRects();M<T.length;M++){var I=T[M],W=I.segInput.index;k.push({seg:W<e.length?e[W]:S[W-e.length].entries.map(E),isVisible:!0,left:I.spanStart,right:I.spanEnd,top:I.levelCoord}),P=Math.max(P,I.levelCoord+I.thickness)}return[k.concat(u,D,C),P]}var N=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.slicer=new M,n.sortEventSegs=t.memoize(t.sortEventSegs),n.computeFgSegPlacements=t.memoize(x),n.harnessElRefs=new t.RefMap,n.moreElRefs=new t.RefMap,n.innerElRef=t.createRef(),n.state={eventInstanceHeights:{},moreLinkHeights:{}},n}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.state,i=this.context,r=i.options,o=e.dateProfile,a=e.tDateProfile,s=this.slicer.sliceProps(e,o,a.isTimeScale?null:e.nextDayThreshold,i,o,i.dateProfileGenerator,a,i.dateEnv),l=(s.eventDrag?s.eventDrag.segs:null)||(s.eventResize?s.eventResize.segs:null)||[],c=this.sortEventSegs(s.fgEventSegs,r.eventOrder),u=this.computeFgSegPlacements(c,e.timelineCoords,n.eventInstanceHeights,n.moreLinkHeights,r.eventMinWidth,i.isRtl,r.eventOrderStrict,r.eventMaxStack),d=u[0],f=u[1],h=(s.eventDrag?s.eventDrag.affectedInstances:null)||(s.eventResize?s.eventResize.affectedInstances:null)||{};return t.createElement(t.Fragment,null,t.createElement(P,{businessHourSegs:s.businessHourSegs,bgEventSegs:s.bgEventSegs,timelineCoords:e.timelineCoords,eventResizeSegs:s.eventResize?s.eventResize.segs:[],dateSelectionSegs:s.dateSelectionSegs,nowDate:e.nowDate,todayRange:e.todayRange}),t.createElement("div",{className:"fc-timeline-events fc-scrollgrid-sync-inner",ref:this.innerElRef,style:{height:f}},this.renderFgSegs(d,h),this.renderFgSegs(function(e,t,n){if(!e.length||!t)return[];var i=function(e){for(var t={},n=0,i=e;n<i.length;n++){var r=i[n],o=r.seg;Array.isArray(o)||(t[o.eventRange.instance.instanceId]=r.top)}return t}(n);return e.map((function(e){var n=t.rangeToCoords(e);return{seg:e,isVisible:!0,left:n.left,right:n.right,top:i[e.eventRange.instance.instanceId]}}))}(l,e.timelineCoords,d),{},Boolean(s.eventDrag),Boolean(s.eventResize),!1)))},n.prototype.componentDidMount=function(){this.updateSize()},n.prototype.componentDidUpdate=function(e,t){e.eventStore===this.props.eventStore&&e.timelineCoords===this.props.timelineCoords&&t.moreLinkHeights===this.state.moreLinkHeights||this.updateSize()},n.prototype.updateSize=function(){var e=this,n=this.props,i=n.timelineCoords;n.onHeightChange&&n.onHeightChange(this.innerElRef.current,!1),i&&this.setState({eventInstanceHeights:t.mapHash(this.harnessElRefs.currentMap,(function(e){return Math.round(e.getBoundingClientRect().height)})),moreLinkHeights:t.mapHash(this.moreElRefs.currentMap,(function(e){return Math.round(e.getBoundingClientRect().height)}))},(function(){n.onHeightChange&&n.onHeightChange(e.innerElRef.current,!0)}))},n.prototype.renderFgSegs=function(e,n,i,r,o){var a=this.harnessElRefs,s=this.moreElRefs,c=this.props,u=i||r||o;return t.createElement(t.Fragment,null,e.map((function(e){var d=e.seg;if(Array.isArray(d)){var f=t.buildIsoString(t.computeEarliestSegStart(d));return t.createElement(W,{key:"m:"+f,elRef:s.createRef(f),hiddenSegs:d,placement:e,dateProfile:c.dateProfile,nowDate:c.nowDate,todayRange:c.todayRange,isTimeScale:c.tDateProfile.isTimeScale,eventSelection:c.eventSelection,resourceId:c.resourceId,isForcedInvisible:n})}var h=d.eventRange.instance.instanceId,m=e.isVisible&&!n[h];return t.createElement("div",{key:"e:"+h,ref:u?null:a.createRef(h),className:"fc-timeline-event-harness",style:{left:e.left,right:-e.right,top:e.top,visibility:m?"":"hidden"}},t.createElement(I,l({isTimeScale:c.tDateProfile.isTimeScale,seg:d,isDragging:i,isResizing:r,isDateSelecting:o,isSelected:h===c.eventSelection},t.getSegMeta(d,c.todayRange,c.nowDate))))})))},n}(t.BaseComponent);N.addStateEquality({eventInstanceHeights:t.isPropsEqual,moreLinkHeights:t.isPropsEqual});var L=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.slatsRef=t.createRef(),n.state={coords:null},n.handeEl=function(e){e?n.context.registerInteractiveComponent(n,{el:e}):n.context.unregisterInteractiveComponent(n)},n.handleCoords=function(e){n.setState({coords:e}),n.props.onSlatCoords&&n.props.onSlatCoords(e)},n}return s(n,e),n.prototype.render=function(){var e=this,n=this.props,i=this.state,r=this.context.options,o=n.dateProfile,a=n.tDateProfile,s=t.greatestDurationDenominator(a.slotDuration).unit;return t.createElement("div",{className:"fc-timeline-body",ref:this.handeEl,style:{minWidth:n.tableMinWidth,height:n.clientHeight,width:n.clientWidth}},t.createElement(t.NowTimer,{unit:s},(function(s,l){return t.createElement(t.Fragment,null,t.createElement(k,{ref:e.slatsRef,dateProfile:o,tDateProfile:a,nowDate:s,todayRange:l,clientWidth:n.clientWidth,tableColGroupNode:n.tableColGroupNode,tableMinWidth:n.tableMinWidth,onCoords:e.handleCoords,onScrollLeftRequest:n.onScrollLeftRequest}),t.createElement(N,{dateProfile:o,tDateProfile:n.tDateProfile,nowDate:s,todayRange:l,nextDayThreshold:r.nextDayThreshold,businessHours:n.businessHours,eventStore:n.eventStore,eventUiBases:n.eventUiBases,dateSelection:n.dateSelection,eventSelection:n.eventSelection,eventDrag:n.eventDrag,eventResize:n.eventResize,timelineCoords:i.coords}),r.nowIndicator&&i.coords&&i.coords.isDateInRange(s)&&t.createElement("div",{className:"fc-timeline-now-indicator-container"},t.createElement(t.NowIndicatorRoot,{isAxis:!1,date:s},(function(e,n,r,o){return t.createElement("div",{ref:e,className:["fc-timeline-now-indicator-line"].concat(n).join(" "),style:{left:i.coords.dateToCoord(s)}},o)}))))})))},n.prototype.queryHit=function(e,t,n,i){var r=this.slatsRef.current.positionToHit(e);return r?{dateProfile:this.props.dateProfile,dateSpan:r.dateSpan,rect:{left:r.left,right:r.right,top:0,bottom:i},dayEl:r.dayEl,layer:0}:null},n}(t.DateComponent),H=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.buildTimelineDateProfile=t.memoize(u),n.scrollGridRef=t.createRef(),n.state={slatCoords:null,slotCushionMaxWidth:null},n.handleSlatCoords=function(e){n.setState({slatCoords:e})},n.handleScrollLeftRequest=function(e){n.scrollGridRef.current.forceScrollLeft(0,e)},n.handleMaxCushionWidth=function(e){n.setState({slotCushionMaxWidth:Math.ceil(e)})},n}return s(n,e),n.prototype.render=function(){var e=this,n=this.props,r=this.state,o=this.context,a=o.options,s=!n.forPrint&&t.getStickyHeaderDates(a),c=!n.forPrint&&t.getStickyFooterScrollbar(a),u=this.buildTimelineDateProfile(n.dateProfile,o.dateEnv,a,o.dateProfileGenerator),d=["fc-timeline",!1===a.eventOverlap?"fc-timeline-overlap-disabled":""],f=a.slotMinWidth,h=z(u,f||this.computeFallbackSlotMinWidth(u)),m=[{type:"header",key:"header",isSticky:s,chunks:[{key:"timeline",content:function(i){return t.createElement(R,{dateProfile:n.dateProfile,clientWidth:i.clientWidth,clientHeight:i.clientHeight,tableMinWidth:i.tableMinWidth,tableColGroupNode:i.tableColGroupNode,tDateProfile:u,slatCoords:r.slatCoords,onMaxCushionWidth:f?null:e.handleMaxCushionWidth})}}]},{type:"body",key:"body",liquid:!0,chunks:[{key:"timeline",content:function(i){return t.createElement(L,l({},n,{clientWidth:i.clientWidth,clientHeight:i.clientHeight,tableMinWidth:i.tableMinWidth,tableColGroupNode:i.tableColGroupNode,tDateProfile:u,onSlatCoords:e.handleSlatCoords,onScrollLeftRequest:e.handleScrollLeftRequest}))}}]}];return c&&m.push({type:"footer",key:"footer",isSticky:!0,chunks:[{key:"timeline",content:t.renderScrollShim}]}),t.createElement(t.ViewRoot,{viewSpec:o.viewSpec},(function(r,o){return t.createElement("div",{ref:r,className:d.concat(o).join(" ")},t.createElement(i.ScrollGrid,{ref:e.scrollGridRef,liquid:!n.isHeightAuto&&!n.forPrint,collapsibleWidth:!1,colGroups:[{cols:h}],sections:m}))}))},n.prototype.computeFallbackSlotMinWidth=function(e){return Math.max(30,(this.state.slotCushionMaxWidth||0)/e.slotsPerLabel)},n}(t.DateComponent);function z(e,t){return[{span:e.slotCnt,minWidth:t||1}]}var O=t.createPlugin({deps:[o.default],initialView:"timelineDay",views:{timeline:{component:H,usesMinMaxTime:!0,eventResizableFromStart:!0},timelineDay:{type:"timeline",duration:{days:1}},timelineWeek:{type:"timeline",duration:{weeks:1}},timelineMonth:{type:"timeline",duration:{months:1}},timelineYear:{type:"timeline",duration:{years:1}}}});return t.globalPlugins.push(O),e.TimelineCoords=C,e.TimelineHeader=R,e.TimelineHeaderRows=S,e.TimelineLane=N,e.TimelineLaneBg=P,e.TimelineLaneSlicer=M,e.TimelineSlats=k,e.TimelineView=H,e.buildSlatCols=z,e.buildTimelineDateProfile=u,e.default=O,Object.defineProperty(e,"__esModule",{value:!0}),e}({},FullCalendar,FullCalendarPremiumCommon,FullCalendarScrollGrid);